//=============================================================================
// unrealapacheweaponv2.
//=============================================================================
class unrealapacheweaponv2 expands Weapon;

var UnrealApacheWeaponV2 UAW;
struct   sPalette
{
   var()   color   Green;
};
const   RDot = Texture'HeliRadarHUDV2.Redradardot';
const   BDot = Texture'HeliRadarHUDV2.Blueradardot';
const   RFlag = Texture'HeliRadarHUDV2.RdRdarFlg';
const   BFlag = Texture'HeliRadarHUDV2.BluRdarFlg';
const   Rdar = Texture'HeliRadarHUDV2.HeliRadarGre_A000';
const   ApacheTex = Texture'HeliRadarHUDV2.RDRdarFlg';
const	LTarget= Texture'HeliRadarHUDV2.UAHST_000';
var()   texture RadarTexture[4];
var()   sPalette      Palette;
var color       TeamColor[4];
var byte      cTeam;
//-----------------------------

//----------------------------
//HUD MessageColors

var() color col1;  // Main HUD color.
var() color col2;
var() color col3;
var() color col4;
var() color col5;
var() color col6;
var float screenFade;
//-----------------------------

//----------------------------
//HUD Messages

var string FuelMessage;
var string RocketMessage;
Var String HeatSeekerMessage;
Var String CannonMessage;
var string Shieldmessage;
Var string FuelAmountMessage;
//-----------------------------

//-----------------------------
//Weapon Switch Controls

var() int FireType;
var int AllowFire;
var travel UnrealApacheRocketsV2 shot;
var travel UnrealApacheHeatSeekerV2 Shtt;
var() travel int missles;
var() travel int NumRockets;
var() travel int NumCannons;
var int Count;
var() int RadiusDamage;
var() int NumBombings;
//-----------------------------

//-----------------------------
//Health And Fuel Vars

var UnrealApacheEffectV2 UAE;
var uaammo AH;
var() float u2m;

//-----------------------------

//-----------------------------
//SoundEffects

var() Sound NoAmmo;
var() Sound RadarFContact;
var() Sound Gunfire;
//-----------------------------------------------------------------------------

replication
{
	// Things the server should send to the client.
	reliable if( bNetOwner && (Role==ROLE_Authority) )
		AH,FuelAmountMessage,Shieldmessage,NumCannons,NumRockets,missles,RocketMessage,HeatSeekerMessage,CannonMessage,FireType,NumBombings;

}
 
//---------------------------------------------------------------
//Radar Begin  this starts the Radar







simulated function PostRender( canvas Canvas )
{
local float  Dist;
	local Pawn P;
	local int XPos, YPos;
	local Vector X,Y,Z, Dir;

GetAxes(Rotation, X,Y,Z);
   if ( PlayerPawn(Owner) != None )
   {

       DrawRadar(Canvas, 0.5 * Canvas.ClipX - 64, 16);
       Canvas.Font = Font'WhiteFont';


	FuelMessage = "Toss Weapon to Exit";
	Canvas.SetPos(575,319 );
	Canvas.drawColor = col1;
	Canvas.DrawText(FuelMessage);


	FuelMessage = "AltFire To Change Weapon Type";
	Canvas.SetPos(575, 310);
	Canvas.drawColor = col1;
	Canvas.DrawText(FuelMessage);

	//Fuel Amount
/*
	FuelAmountMessage = "Fuel: " $String (FuelAmount);
	Canvas.SetPos(575, 301);
	Canvas.drawColor = col1;
	Canvas.DrawText(FuelAmountMessage);

	//Low Fuel
	If (FuelAmount < 20)
	{
	FuelAmountMessage = "Fuel: " $String (FuelAmount);
	Canvas.SetPos(575, 301);
	Canvas.drawColor = col4;
	Canvas.DrawText(FuelAmountMessage);
	}
*/
if (AH == none)
     AH = uaammo(pawn(owner).findInventoryType(class'uaammo'));
if ( AmmoType == None )
	{
	giveammo(pawn(owner));
	}

     AH = uaammo(Pawn(owner).findInventoryType(class'uaammo'));
if(ah!=none)
{
if(ah.ammoamount <=0)
destroy();
}


if(ammotype.ammoamount > 3500)
ammotype.ammoamount = 3500;

         Shieldmessage = "Apache Hull: " $String (AH.ammoAmount);
		 Canvas.SetPos(575, 301);
		 Canvas.drawColor = col2;
		 Canvas.DrawText(Shieldmessage);
			if (ammoType.ammoAmount < 80)
			{
		Shieldmessage = "Apache Hull: " $String (AH.ammoAmount);
		 Canvas.SetPos(575, 301);
		 Canvas.drawColor = col4;
		 Canvas.DrawText(Shieldmessage);
			}


	Canvas.Font = Font'TinyWhiteFont';
	if ( Level.bHighDetailMode )
		Canvas.Style = ERenderStyle.STY_Translucent;
	else
		Canvas.Style = ERenderStyle.STY_Translucent;
	foreach visiblecollidingactors(class'Pawn', P, 6000,, true)
	{
	
			Dir = P.Location - Location;
			Dist = VSize(Dir);
			Dir = Dir/Dist;
			if ( (Dir Dot X) > 0.7 )
			{
				XPos = 0.5 * Canvas.ClipX * (1 + 1.4 * (Dir Dot Y));
				YPos = 0.5 * Canvas.ClipY * (1 - 1.4 * (Dir Dot Z));
				Canvas.SetPos(XPos - 8, YPos - 8);
				Canvas.drawColor = col3;

				//Canvas.drawColor = col3;
				Canvas.DrawIcon(texture'UAHST_000', 0.8);
				Canvas.SetPos(Xpos - 12, YPos + 8);
				Canvas.drawText(int((dist * u2m)));

				//Canvas.DrawText(Dist, true);

			}

		


			Dir = P.Location - Location;
			Dist = VSize(Dir);
			Dir = Dir/Dist;
			if ( (Dir Dot X) > 0.7 )
			{
				XPos = 0.5 * Canvas.ClipX * (1 + 1.4 * (Dir Dot Y));
				YPos = 0.5 * Canvas.ClipY * (1 - 1.4 * (Dir Dot Z));
				Canvas.SetPos(XPos - 8, YPos - 8);
				Canvas.drawColor = col5;

				//Canvas.drawColor = col3;
				Canvas.DrawIcon(texture'UAHST_000', 0.8);
				Canvas.SetPos(Xpos - 12, YPos + 8);
				Canvas.drawText(int((dist * u2m)));



			

		}

		

}

		

}
//---------------------------------------------------------------
// Gives The messages of the Weapon Type Being Used

	switch (FireType)
	{
	case 1:
		Canvas.Font = Font'WhiteFont';
       	CannonMessage = "Cannons: "$String ( NumCannons );
		Canvas.SetPos(575, 265);
		Canvas.drawColor = col6;
		Canvas.DrawText(CannonMessage);	
		
		//Fade Rockets.
		RocketMessage = "Rockets: "$String( NumRockets );
		Canvas.SetPos(575, 274);
		Canvas.drawColor = col1;
		Canvas.DrawText(RocketMessage);
		//Fade HeatSeekers.
		HeatSeekerMessage = "Heat Seekers: "$String( Missles );
		Canvas.SetPos(575, 283);
		Canvas.drawColor = col1;
		Canvas.DrawText(HeatSeekerMessage);

	FuelMessage = "Eject";
	Canvas.SetPos(575,328 );
	Canvas.drawColor = col1;
	Canvas.DrawText(FuelMessage);

	FuelMessage = "Bombings: "$String( numbombings );;
	Canvas.SetPos(575,292 );
	Canvas.drawColor = col1;
	Canvas.DrawText(FuelMessage);
		break;

    case 2:
		Canvas.Font = Font'WhiteFont';
		RocketMessage = "Rockets: "$String( NumRockets );
		Canvas.SetPos(575, 274);
		Canvas.drawColor = col6;
		Canvas.DrawText(RocketMessage);

		//Fade HeatSeekers.
		HeatSeekerMessage = "Heat Seekers: "$String( Missles );
		Canvas.SetPos(575, 283);
		Canvas.drawColor = col1;
		Canvas.DrawText(HeatSeekerMessage);

		//Fade Cannons.
		CannonMessage = "Cannons: "$String ( NumCannons );
		Canvas.SetPos(575, 265);
		Canvas.drawColor = col1;
		Canvas.DrawText(CannonMessage);

	FuelMessage = "Eject";
	Canvas.SetPos(575,328 );
	Canvas.drawColor = col1;
	Canvas.DrawText(FuelMessage);

	FuelMessage = "Bombings: "$String( numbombings );;
	Canvas.SetPos(575,292 );
	Canvas.drawColor = col1;
	Canvas.DrawText(FuelMessage);
		break;

    case 3:
		Canvas.Font = Font'WhiteFont';
		HeatSeekerMessage = "Heat Seekers: "$String ( Missles );
		Canvas.SetPos(575, 283);
		Canvas.drawColor = col6;
		Canvas.DrawText(HeatSeekerMessage);

		//Fade Rockets.
		RocketMessage = "Rockets: "$String ( NumRockets );
		Canvas.SetPos(575, 274);
		Canvas.drawColor = col1;
		Canvas.DrawText(RocketMessage);

		//Fade Cannons.
		CannonMessage = "Cannons: "$String ( NumCannons );
		Canvas.SetPos(575, 265);
		Canvas.drawColor = col1;
		Canvas.DrawText(CannonMessage);

	FuelMessage = "Eject";
	Canvas.SetPos(575,328 );
	Canvas.drawColor = col1;
	Canvas.DrawText(FuelMessage);

	FuelMessage = "Bombings: "$String( numbombings );;
	Canvas.SetPos(575,292 );
	Canvas.drawColor = col1;
	Canvas.DrawText(FuelMessage);
		break;



case 4:
	Canvas.Font = Font'WhiteFont';
	FuelMessage = "Bombings: "$String( numbombings );;
	Canvas.SetPos(575,292 );
	Canvas.drawColor = col6;
	Canvas.DrawText(FuelMessage);


		HeatSeekerMessage = "Heat Seekers: "$String ( Missles );
		Canvas.SetPos(575, 283);
		Canvas.drawColor = col1;
		Canvas.DrawText(HeatSeekerMessage);

		//Fade Rockets.
		RocketMessage = "Rockets: "$String ( NumRockets );
		Canvas.SetPos(575, 274);
		Canvas.drawColor = col1;
		Canvas.DrawText(RocketMessage);

		//Fade Cannons.
		CannonMessage = "Cannons: "$String ( NumCannons );
		Canvas.SetPos(575, 265);
		Canvas.drawColor = col1;
		Canvas.DrawText(CannonMessage);

	FuelMessage = "Eject";
	Canvas.SetPos(575,328 );
	Canvas.drawColor = col1;
	Canvas.DrawText(FuelMessage);

break;


case 5:
	Canvas.Font = Font'WhiteFont';
	FuelMessage = "Eject";
	Canvas.SetPos(575,328 );
	Canvas.drawColor = col6;
	Canvas.DrawText(FuelMessage);


		HeatSeekerMessage = "Heat Seekers: "$String ( Missles );
		Canvas.SetPos(575, 283);
		Canvas.drawColor = col1;
		Canvas.DrawText(HeatSeekerMessage);

		//Fade Rockets.
		RocketMessage = "Rockets: "$String ( NumRockets );
		Canvas.SetPos(575, 274);
		Canvas.drawColor = col1;
		Canvas.DrawText(RocketMessage);

		//Fade Cannons.
		CannonMessage = "Cannons: "$String ( NumCannons );
		Canvas.SetPos(575, 265);
		Canvas.drawColor = col1;
		Canvas.DrawText(CannonMessage);

	
	FuelMessage = "Bombings: "$String( numbombings );;
	Canvas.SetPos(575,292 );
	Canvas.drawColor = col1;
	Canvas.DrawText(FuelMessage);
break;
    	}

	}




Simulated Function Explodeme()
{
	local Pawn Victim;
    local flameexplosion  UAWE;
    local ballexplosion UASW;
    local UnrealApacheExplosionShellV2 UAES;
     Victim = Pawn(Owner);

     if  (Victim != None)
     {
pawn(owner).takedamage(999999999999, pawn(owner), location, location, 'exploded');
		   playerpawn(owner).SetCollisionSize( 17,39);
		   Pawn(Owner).SetCollision(True, True, True);
           UAWE = Spawn(class'flameexplosion ', , , Victim.Location + vect(0,0,50), Victim.Rotation);
           UASW = Spawn(class'ballexplosion ', , , Victim.Location + vect(0,0,50), Victim.Rotation);
                     UAWE.Instigator = Victim;
           UASW.Instigator = Victim;
           
destroy();
          }
}

//---------------------------------------------------------------

//---------------------------------------------------------------
// Draws Radar background image

simulated function DrawRadarBackground(Canvas canvas, int X, int Y)
{
   Canvas.SetPos(X,Y);
   Canvas.Style = ERenderStyle.STY_Normal;
   if (Level.Game.IsA('TeamGame'))
   Canvas.DrawIcon(Texture'HeliRadarGre_A000',0.5);
        else
      Canvas.DrawIcon(Texture'HeliRadarGre_A000', 0.5);
   Canvas.Style = ERenderStyle.STY_Normal;
   Canvas.SetPos(X + 2, Y + 114);
}
//---------------------------------------------------------------

//---------------------------------------------------------------
// Draws pawn Blips
simulated function DrawRadarBlips(Canvas canvas, int RadarX, int RadarY)
{
   local actor blip;
   local int CenterX, CenterY;
   local vector RelLoc;
   local float d, x, y, arc;
   local actor Viewer;

   CenterX = RadarX + 64;
   CenterY = RadarY + 64;
   Viewer = Owner;
   if (PlayerPawn(Owner).ViewTarget != none)
      Viewer = PlayerPawn(Owner).ViewTarget;

   // mark pawn blips
   foreach RadiusActors(class'actor', blip, 100 * 62, Owner.Location)
      if ( blip != None && blip != Owner )
      {
         if (  blip.isa('flockpawn') || blip.isa('flockmasterpawn'))
            continue;
         else
         {

         

         // calculate the corresponding 3D pos. on a 2D area
         // WARNING: heavy math ahead!
         RelLoc = Viewer.Location - blip.Location;
         arc = (Viewer.Rotation.Yaw - 16384) / 182.04 / 360;
         d = arc * 2 * PI;
         x =  RelLoc.X * cos(d) + RelLoc.Y * sin(d);
         y = -RelLoc.X * sin(d) + RelLoc.Y * cos(d);
         x /= 100;
         y /= 100;
         x += CenterX - 1;
         y += CenterY - 1;

         Canvas.SetPos(x,y);

if(blip.isa('playerpawn'))
Canvas.DrawIcon(BDot, 3.0);
else
if(blip.isa('scriptedpawn'))
Canvas.DrawIcon(rDot, 3.0);
else
if(blip.isa('unrealapachev2'))
if(unrealapachev2(blip).owner == pawn(owner))
continue;
else
Canvas.DrawIcon(apachetex, 1.0);
}
}
}




//---------------------------------------------------------------

//---------------------------------------------------------------
//Starts the Whole Radar Process
simulated function DrawRadar(canvas Canvas, int X, int Y)
{
   DrawRadarBackground(canvas, X, Y);
   DrawRadarBlips(canvas, X, Y);

}
//---------------------------------------------------------------

//---------------------------------------------------------------
// Return the switch priority of the weapon (normally AutoSwitchPriority, but may be
function float SwitchPriority()
{
     return 20;
}
//---------------------------------------------------------------
//Gives the Illiusion of going straight up since we cant use cheat fly

//---------------------------------------------------------------

//---------------------------------------------------------------
// Added in case Weapon not fully gone when player ejects




function DropInventory()
{
     local Inventory S;

foreach radiusactors(class'unrealapacheeffectv2',uae,2.0,location)
{
if(uae.owner == playerpawn(owner))
uae.mesh = none;
}
spawn(class'apachedummy3',,,location,rotation);

     S = Pawn(Owner).FindInventoryType(class'UnrealApacheV2');
          if ( (S == None))
          Pawn(Owner).deleteInventory(UAW);
}




//---------------------------------------------------------------

//---------------------------------------------------------------
// timer function added with bduck allows for switching Fire typs when Duck/Crouch Button is pushed.
//---------------------------------------------------------------

//---------------------------------------------------------------
//Trace Fire 
function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{

	if ( RadiusDamage < 4096 ) RadiusDamage = 35;
	if (Other == Level)
	{
		Spawn(class'HeavyWallHitEffect',,, HitLocation+HitNormal, Rotator(HitNormal));
		HurtRadius(RadiusDamage, 35, 'mortared', 2000, HitLocation);
	}
	else if ( (Other != self) && (Other != Owner) && (Other != None) )
	{
		if ( !Other.bIsPawn && !Other.IsA('Carcass') )
			spawn(class'SpriteSmokePuff',,,HitLocation+HitNormal*9);
		else
			Other.PlaySound(Sound 'ChunkHit',, 4.0,,100);

		if ( Other.bIsPawn && (HitLocation.Z - Other.Location.Z > 0.62 * Other.CollisionHeight)
			&& (instigator.IsA('PlayerPawn') ))
			Other.TakeDamage(230, Pawn(Owner), HitLocation, 35000 * X, AltDamageType);
		else
			Other.TakeDamage(121,  Pawn(Owner), HitLocation, 30000.0*X, MyDamageType);
		if ( !Other.bIsPawn && !Other.IsA('Carcass') )
			spawn(class'SpriteSmokePuff',,,HitLocation+HitNormal*9);
	}
}

function TraceFire( float Accuracy )
{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z, AimDir;
	local actor Other;
if ( NumCannons > 0 ) {
			NumCannons --;
	Owner.MakeNoise(Pawn(Owner).SoundDampening);

	GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
StartTrace = Owner.Location + CalcDrawOffset();
//Left Side
StartTrace = StartTrace + (FireOffset.X -10) * X  + (FireOffset.Y - 55) * Y + (FireOffset.Z + 5) * Z;


	AdjustedAim = pawn(owner).AdjustAim(1000000, StartTrace, 2.75*AimError, False, False);		Spawn(class'MercFlare',,,StartTrace,AdjustedAim);

	EndTrace = StartTrace + Accuracy * (FRand() - 0.5 )* Y * 1000
		+ Accuracy * (FRand() - 0.5 ) * Z * 1000;
	AimDir = vector(AdjustedAim);
	EndTrace += (10000 * AimDir);
	Other = Pawn(Owner).TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);

	Count++;
	if ( Count == 4 )
	{
		Count = 0;
		if ( VSize(HitLocation - StartTrace) > 250 )
				}
	ProcessTraceHit(Other, HitLocation, HitNormal, vector(AdjustedAim),Y,Z);
}
}

function UATraceFire( float Accuracy )
{
	local vector HitLocation, HitNormal, UAStartTrace, UAEndTrace, X,Y,Z, AimDir;
	local actor Other;
if ( NumCannons > 0 ) {
			NumCannons --;
	Owner.MakeNoise(Pawn(Owner).SoundDampening);
	GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
UAStartTrace = Owner.Location + CalcDrawOffset();

UAStartTrace = UAStartTrace + (FireOffset.X -10) * X  + (FireOffset.Y + 80) * Y + (FireOffset.Z + 2) * Z;


	AdjustedAim = pawn(owner).AdjustAim(1000000, UAStartTrace, 2.75*AimError, False, False);		Spawn(class'MercFlare',,,UAStartTrace,AdjustedAim);

	UAEndTrace = UAStartTrace + Accuracy * (FRand() - 0.5 )* Y * 1000
		+ Accuracy * (FRand() - 0.5 ) * Z * 1000;
	AimDir = vector(AdjustedAim);
	UAEndTrace += (10000 * AimDir);

	Other = Pawn(Owner).TraceShot(HitLocation,HitNormal,UAEndTrace,UAStartTrace);

	Count++;
	if ( Count == 4 )
	{
		Count = 0;
		
			 	}

	ProcessTraceHit(Other, HitLocation, HitNormal, vector(AdjustedAim),Y,Z);
}
}
//---------------------------------------------------------------

//---------------------------------------------------------------
// Plays Sound when HeatSeeker activated
Function RadarSound()

{
if ( missles > 0 )
					 
	PlaySound(RadarFContact, SLOT_none, 3.0);
					
	if ( missles == 0 )
	PlaySound(NoAmmo, SLOT_none, 0.4);

}
//---------------------------------------------------------------

//---------------------------------------------------------------
// Plays Warning Sound When Weapons are out of Ammo
Function RocketEmptySound()
{
if ( NumRockets == 0) 
PlaySound(NoAmmo, SLOT_none, 0.4);
}

Function CannonsEmptySound()
{
if ( NumCannons == 0) 
PlaySound(NoAmmo, SLOT_none, 0.4);
}
//---------------------------------------------------------------

//---------------------------------------------------------------
//Fire
    function Fire( float Value )
{
     local Vector Start, X,Y,Z;
  local Inventory S;
local apachedummy2 ad2;
local pawn p;
		  AllowFire = 0;
if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}

bPointing=True;
          bRapidFire=True;
         
          Owner.MakeNoise(Pawn(Owner).SoundDampening);
          GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
          Start = Owner.Location + CalcDrawOffset();
          Spawn(class'WeaponLight',,'',Start+X*20,rot(0,0,0));
switch (FireType)
          {

          case 1:
 
          GotoState('AltFiring');
		
		 TraceFire(0.0);
		 UATraceFire(0.0);
	
          break;

          case 2:

if ( NumRockets > 0 ) {
			NumRockets --;

           //LeftSide
          Start = Start + (FireOffset.X +70) * X + (FireOffset.Y - 75) * Y + (FireOffset.Z - 30) * Z;
          AdjustedAim = pawn(owner).AdjustToss(AltProjectileSpeed, Start, AimError, True, bAltWarnTarget);
          shot = Spawn(class'UnrealApacheRocketsV2',,, Start,AdjustedAim);

          //RightSide
          Start = Start + (FireOffset.X +10) * X + (FireOffset.Y + 185) * Y + (FireOffset.Z + 0) * Z;

          AdjustedAim = pawn(owner).AdjustToss(AltProjectileSpeed, Start, AimError, True, bAltWarnTarget);
          shot = Spawn(class'UnrealApacheRocketsV2',,, Start,AdjustedAim);

}
 break;

		case 3:
if ( missles > 0 ) {
			missles --;

           //LeftSide
          Start = Start + (FireOffset.X +70) * X + (FireOffset.Y - 75) * Y + (FireOffset.Z - 30) * Z;
          AdjustedAim = pawn(owner).AdjustToss(AltProjectileSpeed, Start, AimError, True, bAltWarnTarget);
          Shtt = Spawn(class'UnrealApacheHeatSeekerV2',,, Start,AdjustedAim);

          //RightSide
          Start = Start + (FireOffset.X +10) * X + (FireOffset.Y + 186) * Y + (FireOffset.Z + 0) * Z;

          AdjustedAim = pawn(owner).AdjustToss(AltProjectileSpeed, Start, AimError, True, bAltWarnTarget);
          Shtt = Spawn(class'UnrealApacheHeatSeekerV2',,, Start,AdjustedAim);
}
 break;

case 4:
if(numbombings>0)
{
gotostate('dropbomb');
}

break;

case 5:

     P = PlayerPawn(Owner);
     P.bCanTeleport=True;
	 P.SetCollisionSize(17,39);
	 P.SetCollision(True, True, True);
     P.JumpZ = P.Default.JumpZ * Level.Game.PlayerJumpZScaling();
     P.AirControl =P.Default.AirControl;
     P.GroundSpeed =P.Default.GroundSpeed;
     P.WaterSpeed = P.Default.WaterSpeed;
     P.AirSpeed = P.Default.AirSpeed;
     P.Acceleration = P.Default.Acceleration;
     p.SetPhysics(PHYS_Falling);
playerpawn(owner).addvelocity(vect(0,0,2300));
s = spawn(class'parachutepickup',,,p.location);
s.respawntime = 0;
s.touch(p);
foreach radiusactors(class'unrealapacheeffectv2',uae,2.0,location)
{
if(uae.owner == playerpawn(owner))
{
uae.mesh = none;
ad2 = spawn(class'apachedummy2',,,location,rotation);
ad2.setrotation(uae.rotation);
}
}

destroy();
break;
}
}
//---------------------------------------------------------------




state dropbomb
{
ignores fire, altfire;
begin:
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
sleep(0.2);
spawn(class'unrealapacheexplosionshellv2',,,location);
numbombings-=1;
sleep(1.5);
finish();
}
function bool putDown() {
     if (Owner != none)

     bChangeWeapon =False;
     Pawn(owner).pendingWeapon = UAW;

     return true;
}
state Idle {

     function bool putDown() {
          return global.putDown();

     }
}

state NormalFire
{
//ignores Fire;

Begin:
if (Pawn(Owner).Weapon != self) GotoState('');
          else if (Pawn(Owner).bFire!=0 && AmmoType.AmmoAmount>0)
               Global.Fire(0);
     Else sleep(0.02);
     Finish();
}

State AltFiring
{
simulated function bool clientFire(float v) {
     return false;


}
Begin:
if (Pawn(Owner).Weapon != self) GotoState('');
          else if (Pawn(Owner).bAltFire!=0 && AmmoType.AmmoAmount>0)
               Global.AltFire(0);
     Else sleep(0.16);

     Finish();

}

state ClientActive {

     simulated function beginState() {
          // Nothing.
     }
}

auto state Active {

     function bool putDown() {
          return global.putDown();
     }

     function beginState() {
          // Nothing.
     }

     function endState() {
          // Nothing.
     }
     begin:
     // Nothing.

}

state DownWeapon
{
     function bool putDown()
     {
      return global.putDown();
     }
}

simulated function setHand(float hand)
{
     // Nothing.
}

// These keep those accessed none warnings at bay.
simulated function PlaySelect()
{

}





simulated function tweenToStill()
{
     // No mesh. Nothing.
}

function bringUp()
{
     // Nothing.
}

function altfire(optional float f)
{
FireType = FireType + 1;
      if ( FireType > 5 || FireType < 1 )
	 {



          FireType = 1;
     }

        switch (FireType)
          {
          case 1:
               If ( Pawn(Owner).bIsPlayer )
                    Pawn(Owner).ClientMessage("Unreal Apache using Cannons");


               break;
          case 2:
               If ( Pawn(Owner).bIsPlayer )
                    Pawn(Owner).ClientMessage("Unreal Apache using Rockets");
					RocketEmptySound();

               break;
			case 3:
               If ( Pawn(Owner).bIsPlayer )
				
                    Pawn(Owner).ClientMessage("Unreal Apache using Missles");
					RadarSound();

			
               break;

case 4:
    If ( Pawn(Owner).bIsPlayer )
				
                    Pawn(Owner).ClientMessage("Unreal Apache in Bombing Mode");
break;

case 5:
    If ( Pawn(Owner).bIsPlayer )
				
                    Pawn(Owner).ClientMessage("Eject Mode");
break;


      }
 
}


State Finishing
{
     ignores Fire, AltFire;
Begin:
}

defaultproperties
{
				col1=(R=75,G=200,B=100)
				col2=(R=255,G=255,B=128)
				col3=(R=255)
				col4=(R=253,G=28,B=72)
				col5=(R=24,G=167,B=243)
				col6=(R=252,G=240,B=20)
				firetype=1
				missles=100
				NumRockets=60
				NumCannons=600
				RadiusDamage=200
				NumBombings=10
				u2m=0.020000
				NoAmmo=Sound'uapachesounds.Alert'
				RadarFContact=Sound'uapachesounds.RadarContact'
				Gunfire=Sound'UnrealI.Minigun.RegF1'
				AmmoName=Class'GNP.uaammo'
				PickupAmmoCount=3500
				bAltInstantHit=True
				bRapidFire=True
				FiringSpeed=5.000000
				FireOffset=(X=50.000000,Y=5.000000,Z=-4.000000)
				FireSound=Sound'UnrealI.Minigun.AltF1'
				Misc1Sound=Sound'UnrealI.Minigun.WindD2'
				InventoryGroup=20
				RespawnTime=0.000000
				CollisionRadius=-10.000000
				CollisionHeight=-10.000000
				bCollideActors=False
				Mass=15.000000
}
